返回介绍

lcof2 / 剑指 Offer II 088. 爬楼梯的最少成本 / README

发布于 2024-06-17 01:04:41 字数 4479 浏览 0 评论 0 收藏 0

剑指 Offer II 088. 爬楼梯的最少成本

题目描述

数组的每个下标作为一个阶梯,第 i 个阶梯对应着一个非负数的体力花费值 cost[i](下标从 0 开始)。

每当爬上一个阶梯都要花费对应的体力值,一旦支付了相应的体力值,就可以选择向上爬一个阶梯或者爬两个阶梯。

请找出达到楼层顶部的最低花费。在开始时,你可以选择从下标为 0 或 1 的元素作为初始阶梯。

 

示例 1:

输入:cost = [10, 15, 20]
输出:15
解释:最低花费是从 cost[1] 开始,然后走两步即可到阶梯顶,一共花费 15 。

 示例 2:

输入:cost = [1, 100, 1, 1, 1, 100, 1, 1, 100, 1]
输出:6
解释:最低花费方式是从 cost[0] 开始,逐个经过那些 1 ,跳过 cost[3] ,一共花费 6 。

 

提示:

  • 2 <= cost.length <= 1000
  • 0 <= cost[i] <= 999

 

注意:本题与主站 746 题相同: https://leetcode.cn/problems/min-cost-climbing-stairs/

解法

方法一:动态规划

定义 dp[i] 表示到达第 i 个台阶的最小花费。可以得到状态转移方程:

$$ dp[i] = \min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2]) $$

最终结果为 dp[n]。其中 $n$ 表示 cost 数组的长度。

时间复杂度 $O(n)$,空间复杂度 $O(n)$。

由于 dp[i] 只跟 dp[i-1]dp[i-2] 有关,因此我们还可以对空间进行优化,只用两个变量 a, b 来记录。

时间复杂度 $O(n)$,空间复杂度 $O(1)$。

class Solution:
  def minCostClimbingStairs(self, cost: List[int]) -> int:
    n = len(cost)
    dp = [0] * (n + 1)
    for i in range(2, n + 1):
      dp[i] = min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2])
    return dp[-1]
class Solution {
  public int minCostClimbingStairs(int[] cost) {
    int n = cost.length;
    int[] dp = new int[n + 1];
    for (int i = 2; i <= n; ++i) {
      dp[i] = Math.min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2]);
    }
    return dp[n];
  }
}
class Solution {
public:
  int minCostClimbingStairs(vector<int>& cost) {
    int n = cost.size();
    vector<int> dp(n + 1);
    for (int i = 2; i <= n; ++i) {
      dp[i] = min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2]);
    }
    return dp[n];
  }
};
func minCostClimbingStairs(cost []int) int {
  n := len(cost)
  dp := make([]int, n+1)
  for i := 2; i <= n; i++ {
    dp[i] = min(dp[i-1]+cost[i-1], dp[i-2]+cost[i-2])
  }
  return dp[n]
}
function minCostClimbingStairs(cost: number[]): number {
  const n = cost.length;
  const dp = new Array(n + 1).fill(0);
  for (let i = 2; i <= n; ++i) {
    dp[i] = Math.min(dp[i - 1] + cost[i - 1], dp[i - 2] + cost[i - 2]);
  }
  return dp[n];
}

方法二

class Solution:
  def minCostClimbingStairs(self, cost: List[int]) -> int:
    a = b = 0
    for i in range(1, len(cost)):
      a, b = b, min(a + cost[i - 1], b + cost[i])
    return b
class Solution {
  public int minCostClimbingStairs(int[] cost) {
    int a = 0, b = 0;
    for (int i = 1; i < cost.length; ++i) {
      int c = Math.min(a + cost[i - 1], b + cost[i]);
      a = b;
      b = c;
    }
    return b;
  }
}
class Solution {
public:
  int minCostClimbingStairs(vector<int>& cost) {
    int a = 0, b = 0;
    for (int i = 1; i < cost.size(); ++i) {
      int c = min(a + cost[i - 1], b + cost[i]);
      a = b;
      b = c;
    }
    return b;
  }
};
func minCostClimbingStairs(cost []int) int {
  a, b := 0, 0
  for i := 1; i < len(cost); i++ {
    a, b = b, min(a+cost[i-1], b+cost[i])
  }
  return b
}
function minCostClimbingStairs(cost: number[]): number {
  let a = 0,
    b = 0;
  for (let i = 1; i < cost.length; ++i) {
    [a, b] = [b, Math.min(a + cost[i - 1], b + cost[i])];
  }
  return b;
}

如果你对这篇内容有疑问,欢迎到本站社区发帖提问 参与讨论,获取更多帮助,或者扫码二维码加入 Web 技术交流群。

扫码二维码加入Web技术交流群

发布评论

需要 登录 才能够评论, 你可以免费 注册 一个本站的账号。
列表为空,暂无数据
    我们使用 Cookies 和其他技术来定制您的体验包括您的登录状态等。通过阅读我们的 隐私政策 了解更多相关信息。 单击 接受 或继续使用网站,即表示您同意使用 Cookies 和您的相关数据。
    原文